- Elementary
- Main
- Authors
- Examples
- Files
- Pages
- Types
- Modules

Macros | Typedefs | Enumerations | Functions
GLView

## Macros
#define | elm_obj_glview_gl_api_get(ret) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_GL_API_GET), EO_TYPECHECK(Evas_GL_API **, ret)
#define | elm_obj_glview_mode_set(mode, ret) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_MODE_SET), EO_TYPECHECK(Elm_GLView_Mode, mode), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_glview_resize_policy_set(policy, ret) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RESIZE_POLICY_SET), EO_TYPECHECK(Elm_GLView_Resize_Policy, policy), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_glview_render_policy_set(policy, ret) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RENDER_POLICY_SET), EO_TYPECHECK(Elm_GLView_Render_Policy, policy), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_glview_size_set(w, h) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_SIZE_SET), EO_TYPECHECK(int, w), EO_TYPECHECK(int, h)
#define | elm_obj_glview_size_get(w, h) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_SIZE_GET), EO_TYPECHECK(int *, w), EO_TYPECHECK(int *, h)
#define | elm_obj_glview_init_func_set(func) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_INIT_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)
#define | elm_obj_glview_del_func_set(func) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_DEL_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)
#define | elm_obj_glview_resize_func_set(func) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RESIZE_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)
#define | elm_obj_glview_render_func_set(func) ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RENDER_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)
#define | elm_obj_glview_changed_set() ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_CHANGED_SET)

## Typedefs
typedef enum _Elm_GLView_Mode | Elm_GLView_Mode
| Defines mode of GLView.

## Enumerations
enum | _Elm_GLView_Mode { , ELM_GLVIEW_ALPHA = (1<<1), ELM_GLVIEW_DEPTH = (1<<2), ELM_GLVIEW_STENCIL = (1<<3), ELM_GLVIEW_DIRECT = (1<<4) }
| Defines mode of GLView. More...
enum | Elm_GLView_Resize_Policy { ELM_GLVIEW_RESIZE_POLICY_RECREATE = 1, ELM_GLVIEW_RESIZE_POLICY_SCALE = 2 }
| Defines a policy for the glview resizing. More...
enum | Elm_GLView_Render_Policy { ELM_GLVIEW_RENDER_POLICY_ON_DEMAND = 1, ELM_GLVIEW_RENDER_POLICY_ALWAYS = 2 }
| Defines a policy for gl rendering. More...

## Functions
Evas_Object * | elm_glview_add (Evas_Object *parent)
| Add a new glview to the parent. More...
Evas_GL_API * | elm_glview_gl_api_get (const Evas_Object *obj)
| Get the gl api struct for gl rendering. More...
Eina_Bool | elm_glview_mode_set (Evas_Object *obj, Elm_GLView_Mode mode)
| Set the mode of the GLView. More...
Eina_Bool | elm_glview_resize_policy_set (Evas_Object *obj, Elm_GLView_Resize_Policy policy)
| Set the resize policy for the glview object. More...
Eina_Bool | elm_glview_render_policy_set (Evas_Object *obj, Elm_GLView_Render_Policy policy)
| Set the render policy for the glview object. More...
void | elm_glview_size_set (Evas_Object *obj, Evas_Coord w, Evas_Coord h)
| Sets the size of the glview. More...
void | elm_glview_size_get (const Evas_Object *obj, Evas_Coord *w, Evas_Coord *h)
| Get the size of the glview. More...
void | elm_glview_init_func_set (Evas_Object *obj, Elm_GLView_Func_Cb func)
| Set the init function that runs once in the main loop. More...
void | elm_glview_del_func_set (Evas_Object *obj, Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
void | elm_glview_resize_func_set (Evas_Object *obj, Elm_GLView_Func_Cb func)
| Set the resize function that gets called when resize happens. More...
void | elm_glview_render_func_set (Evas_Object *obj, Elm_GLView_Func_Cb func)
| Set the render function that runs in the main loop. More...
void | elm_glview_changed_set (Evas_Object *obj)
| Notifies that there has been changes in the GLView. More...

## Detailed Description

A GLView widget allows for simple GL rendering in elementary environment. GLView hides all the complicated evas_gl details so that the user only has to deal with registering a few callback functions for rendering to a surface using OpenGL APIs.

This widget emits the following signals, besides the ones sent from GLView:

- `"focused"` - when glview has received focus.
- `"unfocused"` - when glview has lost focus.
- `"language,changed"` - the program's language changed

Below is an illustrative example of how to use GLView and and OpenGL to render in elementary environment.

- GLView Example

## Macro Definition Documentation

#define elm_obj_glview_changed_set | ( |  | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_CHANGED_SET)

Since
  1.8

Notifies that there has been changes in the GLView.

See Also
  elm_glview_changed_set

Referenced by elm_glview_changed_set().

#define elm_obj_glview_del_func_set | ( |  | func | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_DEL_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)

Since
  1.8

Set the render function that runs in the main loop.

Parameters

  [in] | func |

See Also
  elm_glview_del_func_set

Referenced by elm_glview_del_func_set().

#define elm_obj_glview_gl_api_get | ( |  | ret | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_GL_API_GET), EO_TYPECHECK(Evas_GL_API **, ret)

Since
  1.8

Get the gl api struct for gl rendering

Parameters

  [out] | ret |

See Also
  elm_glview_gl_api_get

Referenced by elm_glview_gl_api_get().

#define elm_obj_glview_init_func_set | ( |  | func | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_INIT_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)

Since
  1.8

Set the init function that runs once in the main loop.

Parameters

  [in] | func |

See Also
  elm_glview_init_func_set

Referenced by elm_glview_init_func_set().

#define elm_obj_glview_mode_set | ( |  | mode,
|  |  | ret
| ) |  | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_MODE_SET), EO_TYPECHECK(Elm_GLView_Mode, mode), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Set the mode of the GLView. Supports alpha, depth, stencil.

Parameters

  [in] | mode |
  [out] | ret |

See Also
  elm_glview_mode_set

Referenced by elm_glview_mode_set().

#define elm_obj_glview_render_func_set | ( |  | func | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RENDER_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)

Since
  1.8

Set the render function that runs in the main loop.

Parameters

  [in] | func |

See Also
  elm_glview_render_func_set

Referenced by elm_glview_render_func_set().

#define elm_obj_glview_render_policy_set | ( |  | policy,
|  |  | ret
| ) |  | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RENDER_POLICY_SET), EO_TYPECHECK(Elm_GLView_Render_Policy, policy), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Set the render policy for the glview object.

Parameters

  [in] | policy |
  [out] | ret |

See Also
  elm_glview_render_policy_set

Referenced by elm_glview_render_policy_set().

#define elm_obj_glview_resize_func_set | ( |  | func | ) | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RESIZE_FUNC_SET), EO_TYPECHECK(Elm_GLView_Func_Cb, func)

Since
  1.8

Set the resize function that gets called when resize happens.

Parameters

  [in] | func |

See Also
  elm_glview_resize_func_set

Referenced by elm_glview_resize_func_set().

#define elm_obj_glview_resize_policy_set | ( |  | policy,
|  |  | ret
| ) |  | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_RESIZE_POLICY_SET), EO_TYPECHECK(Elm_GLView_Resize_Policy, policy), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Set the resize policy for the glview object.

Parameters

  [in] | policy |
  [out] | ret |

See Also
  elm_glview_resize_policy_set

Referenced by elm_glview_resize_policy_set().

#define elm_obj_glview_size_get | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_SIZE_GET), EO_TYPECHECK(int *, w), EO_TYPECHECK(int *, h)

Since
  1.8

Get the size of the glview.

Parameters

  [out] | w |
  [out] | h |

See Also
  elm_glview_size_get

#define elm_obj_glview_size_set | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GLVIEW_ID(ELM_OBJ_GLVIEW_SUB_ID_SIZE_SET), EO_TYPECHECK(int, w), EO_TYPECHECK(int, h)

Since
  1.8

Sets the size of the glview

Parameters

  [in] | w |
  [in] | h |

See Also
  elm_glview_size_set

## Enumeration Type Documentation

enum _Elm_GLView_Mode

Defines mode of GLView.

Enumerator
ELM_GLVIEW_ALPHA | Alpha channel enabled rendering mode.
ELM_GLVIEW_DEPTH | Depth buffer enabled rendering mode.
ELM_GLVIEW_STENCIL | Stencil buffer enabled rendering mode.
ELM_GLVIEW_DIRECT | Direct rendering optimization hint.

enum Elm_GLView_Render_Policy

Defines a policy for gl rendering.

The rendering policy tells glview where to run the gl rendering code. ELM_GLVIEW_RENDER_POLICY_ON_DEMAND tells glview to call the rendering calls on demand, which means that the rendering code gets called only when it is visible.

Note
  Default is ELM_GLVIEW_RENDER_POLICY_ON_DEMAND

Enumerator
ELM_GLVIEW_RENDER_POLICY_ON_DEMAND | Render only when there is a need for redrawing.
ELM_GLVIEW_RENDER_POLICY_ALWAYS | Render always even when it is not visible.

enum Elm_GLView_Resize_Policy

Defines a policy for the glview resizing.

The resizing policy tells glview what to do with the underlying surface when resize happens. ELM_GLVIEW_RESIZE_POLICY_RECREATE will destroy the current surface and recreate the surface to the new size. ELM_GLVIEW_RESIZE_POLICY_SCALE will instead keep the current surface but only display the result at the desired size scaled.

Note
  Default is ELM_GLVIEW_RESIZE_POLICY_RECREATE

Enumerator
ELM_GLVIEW_RESIZE_POLICY_RECREATE | Resize the internal surface along with the image.
ELM_GLVIEW_RESIZE_POLICY_SCALE | Only resize the internal image and not the surface.

## Function Documentation

Evas_Object* elm_glview_add | ( | Evas_Object * | parent | ) |

Add a new glview to the parent.

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

void elm_glview_changed_set | ( | Evas_Object * | obj | ) |

Notifies that there has been changes in the GLView.

Parameters

  obj | The glview object.

References elm_obj_glview_changed_set.

void elm_glview_del_func_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the render function that runs in the main loop.

Parameters

  obj | The glview object.
  func | The delete function to be registered.

The registered del function gets called when GLView object is deleted. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when delete happens.

References elm_obj_glview_del_func_set.

Evas_GL_API* elm_glview_gl_api_get | ( | const Evas_Object * | obj | ) |

Get the gl api struct for gl rendering.

Parameters

  obj | The glview object

Returns
  The api object or NULL if it cannot be created

References elm_obj_glview_gl_api_get.

void elm_glview_init_func_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the init function that runs once in the main loop.

Parameters

  obj | The glview object.
  func | The init function to be registered.

The registered init function gets called once during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire for initialization GL calls.

References elm_obj_glview_init_func_set.

Eina_Bool elm_glview_mode_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Mode | mode
| ) |  |

Set the mode of the GLView.

Supports alpha, depth, stencil.

Parameters

  obj | The glview object
  mode | The mode Options OR'ed enabling Alpha, Depth, Stencil, Direct.

Returns
  True if set properly.

Direct is a hint for the elm_glview to render directly to the window given that the right conditions are met. Otherwise it falls back to rendering to an offscreen buffer before it gets composited to the window.

References elm_obj_glview_mode_set.

void elm_glview_render_func_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the render function that runs in the main loop.

The render function gets called in the main loop but whether it runs depends on the rendering policy and whether elm_glview_changed_set() gets called.

Parameters

  obj | The glview object.
  func | The render function to be registered.

References elm_obj_glview_render_func_set.

Eina_Bool elm_glview_render_policy_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Render_Policy | policy
| ) |  |

Set the render policy for the glview object.

Parameters

  obj | The glview object.
  policy | The render policy.

By default, the render policy is set to ELM_GLVIEW_RENDER_POLICY_ON_DEMAND. This policy is set such that during the render loop, glview is only redrawn if it needs to be redrawn. (i.e. when it is visible) If the policy is set to ELM_GLVIEWW_RENDER_POLICY_ALWAYS, it redraws regardless of whether it is visible or needs redrawing.

References elm_obj_glview_render_policy_set.

void elm_glview_resize_func_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Func_Cb | func
| ) |  |

Set the resize function that gets called when resize happens.

Parameters

  obj | The glview object.
  func | The resize function to be registered.

The resize function gets called during the render loop. This function allows glview to hide all the rendering context/surface details and have the user just call GL calls that they desire when resize happens.

References elm_obj_glview_resize_func_set.

Eina_Bool elm_glview_resize_policy_set | ( | Evas_Object * | obj,
|  | Elm_GLView_Resize_Policy | policy
| ) |  |

Set the resize policy for the glview object.

Parameters

  obj | The glview object.
  policy | The scaling policy.

By default, the resize policy is set to ELM_GLVIEW_RESIZE_POLICY_RECREATE. When resize is called it destroys the previous surface and recreates the newly specified size. If the policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, however, glview only scales the image object and not the underlying GL Surface.

References elm_obj_glview_resize_policy_set.

void elm_glview_size_get | ( | const Evas_Object * | obj,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h
| ) |  |

Get the size of the glview.

Parameters

  obj | The glview object
  w | width of the glview object
  h | height of the glview object

Note that this function returns the actual image size of the glview. This means that when the scale policy is set to ELM_GLVIEW_RESIZE_POLICY_SCALE, it'll return the non-scaled size.

void elm_glview_size_set | ( | Evas_Object * | obj,
|  | Evas_Coord | w,
|  | Evas_Coord | h
| ) |  |

Sets the size of the glview.

Parameters

  obj | The glview object
  w | width of the glview object
  h | height of the glview object

Copyright ©2000-2014 Enlightenment.org - Samsung Electronics supports the EFL Documentation Project - Generated Wed Jan 8 2014 20:51:13